<?xml version="1.0"?>
<queryset>
<rdbms><type>oracle</type><version>8.1.6</version></rdbms>

<fullquery name="dtype::form::create.create_form">      
      <querytext>
      begin
          :1 = dtype_form.create(
                layout => :layout,
                widget => :widget,
                custom => :custom
          );
      end;
      </querytext>
</fullquery>

<fullquery name="dtype::form::delete.delete_form">      
      <querytext>
      begin
          :1 = dtype_form.delete(:form_id);
      end;
      </querytext>
</fullquery>

<fullquery name="dtype::form::map_type.map_type">      
      <querytext>
      begin
          :1 = dtype_form.map_type(:form_id, :form, :object_type);
      end;
      </querytext>
</fullquery>

<fullquery name="dtype::element::map_attribute.map_attribute">      
      <querytext>
      begin
          :1 = dtype_element.map_attribute(:element_id, :attribute_id);
      end;
      </querytext>
</fullquery>

<fullquery name="dtype::layout::create.create_layout">      
      <querytext>
      begin
          :1 = dtype_layout.create(
                name => :layout,
                pretty_name => :name,
                description => :description,
                type => :type,
                filename => :filename,
                resource_dir => :resource_dir
          );
      end;
      </querytext>
</fullquery>

<fullquery name="dtype::layout::delete.delete_layout">      
      <querytext>
      begin
          :1 = dtype_layout.delete(:layout_id);
      end;
      </querytext>
</fullquery>

<fullquery name="dtype::element::add_element.create_element">      
      <querytext>
      begin
          :1 = dtype_element.create(
                name => :element,
                parent_id => :parent_id,
                widget => :widget,
                layout => :layout,
                custom => :custom
          );
      end;
      </querytext>
</fullquery>

<fullquery name="dtype::element::delete.delete_element">      
      <querytext>
      begin
          :1 = dtype_element.delete(:element_id);
      end;
      </querytext>
</fullquery>

<fullquery name="dtype::upload_content.upload_file_revision">      
      <querytext>

      update cr_revisions 
      set filename =:file_path, content_length = :file_size
      where revision_id = :revision_id
    
      </querytext>
</fullquery>

<fullquery name="dtype::upload_content.upload_text_revision">      
      <querytext>

             update cr_revisions 
             set content = empty_blob(), 
             content_length = [file size $file] 
             where revision_id = :revision_id
             returning content into :1
      
      </querytext>
</fullquery>

<fullquery name="dtype::upload_content.upload_revision">      
      <querytext>

             update cr_revisions 
             set content = empty_blob(), 
             content_length = [file size $file]
             where revision_id = :revision_id
             returning content into :1
      
      </querytext>
</fullquery>

<partialquery name="dtype::form::process.latest_revision">      
      <querytext>
      content_item.get_latest_revision(:item_id)
      </querytext>
</partialquery>
</queryset>
