ad_page_contract {

    @author Vinod Kurup (vinod@kurup.com)
    @creation-date 2006-06-21
} {
}

set user_id [auth::require_login]
permission::require_permission -object_id [ad_conn package_id] -privilege admin

set page_title "Create Type"
set context [list $page_title]

ad_form -name dtype-add -form {
    {name:keyword {label "Name"} {html {size 30 maxlength 100}}}
    {supertype:keyword {label "Supertype"} {html {size 30 maxlength 100}} {value "acs_object"}}
    {pretty_name:text {label "Pretty Name"} {html {size 30 maxlength 100}}}
    {pretty_plural:text {label "Pretty Plural"} {html {size 30 maxlength 100}}}
} -validate {
    {supertype
        {[plsql_utility::object_type_exists_p $supertype] eq 1}
        "Invalid supertype: $supertype is not an acs_object_type on this system."
    }
} -on_submit {
    dtype::create \
        -name $name \
        -supertype $supertype \
        -pretty_name $pretty_name \
        -pretty_plural $pretty_plural \
        -table_name [dtype::table::en_pl $name] \
        -id_column "${name}_id"
} -after_submit {
    ad_returnredirect ./
    ad_script_abort
}

